import java.lang.Math;

public class Drone  {
   public Drone () {
      state = State.LANDED;
      time=0; // for now
      fSpeed=vSpeed=sSpeed=rSpeed=0f;
      direction=0; // in radians
      x=y=90;      h=0f;
      view = new DroneView();
      updateView();  // view shows drone en pane
   }
   static {
      MAX_F_SPEED = MAX_S_SPEED = 50; // [cm/s]
      MAX_V_SPEED = 40;    // [cm/s]
      MAX_R_SPEED = (double)(0.25*Math.PI/2); // [rad/s]
      TAKEOFF_LANDING_SPEED = 20; // [cm/s]
   }
   public void takeAction(){
      // we do not need it yet
   }
   private void updateView() {
      view.setLayoutX(x);
      //...
      view.setRotate(/*...*/);  // this is in degree!!
      view.setScaleX(/*....*/);
      //...
   }
   public void setRotationSpeed(double percentage) {
      rSpeed = percentage*MAX_R_SPEED;
   }
   public void setFlightSpeed(double verPer, double forwPer, double sidePer) {
      vSpeed = verPer*MAX_V_SPEED;
      fSpeed = forwPer*MAX_F_SPEED;
      sSpeed = sidePer*MAX_S_SPEED;
   }
   public State getState() {
      return state;
   }
   public String toString() {
      return x + ", " + y + ", " + h +"," +state;
   }
   public void takeOff() {
      if (state==State.LANDED){
         state = State.TAKING_OFF;
      }
   }
   public void land() {
      if (state!=State.LANDED)
         state = State.LANDING;
   }
   public DroneView getView() {
      return view;
   }
   public double getPosX() {
      return x;
   }
   public double getPosY() {
      return y;
   }
   public double getHeight() {
      return h;
   }
   public void play() {  // to start animation in this stage
      view.play();
   }
   private DroneView view;
   private State state;
   private double time;  // from 1° assignemt
   private double fSpeed, vSpeed, sSpeed, rSpeed;
   private double direction; // angle
   private double x,y,h;
   private static double MAX_F_SPEED;
   private static double MAX_V_SPEED;
   private static double MAX_S_SPEED;
   private static double MAX_R_SPEED;
   private static double TAKEOFF_LANDING_SPEED;
}